using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.XlsIO;


namespace EssentialXlsIOSamples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnImport;
	
		//private System.Data.
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnImport = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// btnImport
			// 
			this.btnImport.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnImport.Location = new System.Drawing.Point(160, 24);
			this.btnImport.Name = "btnImport";
			this.btnImport.Size = new System.Drawing.Size(152, 23);
			this.btnImport.TabIndex = 1;
			this.btnImport.Text = "ImportandExport";
			this.btnImport.Click += new System.EventHandler(this.btnImport_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(504, 94);
			this.Controls.Add(this.btnImport);
			this.Name = "Form1";
			this.Text = "Essential XlsIO Samples";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void btnImport_Click(object sender, System.EventArgs e)
		{
			//Imports Data from the Template spreadsheet into the Grid.

			//New instance of XlsIO is created.[Equivalent to launching MS Excel with no workbooks open].
			//The instantiation process consists of two steps.

			//Step 1 : Instantiate the spreadsheet creation engine.
			ExcelEngine excelEngine = new ExcelEngine();
			//Step 2 : Instantiate the excel application object.
			IApplication application = excelEngine.Excel;

			//Open an existing spreadsheet which will be used as a template for generating the new spreadsheet.
			//After opening, the workbook object represents the complete in-memory object model of the template spreadsheet.
			IWorkbook workbook = application.Workbooks.Open(@"../../Template.XLS"); 
			//The first worksheet object in the worksheets collection is accessed.
			IWorksheet sheet = workbook.Worksheets[0];	
			IWorksheet sheet1 = workbook.Worksheets[1];	
		
			//Read data from spreadsheet.
			DataTable customersTable = sheet.ExportDataTable(sheet.UsedRange,ExcelExportDataTableOptions.DetectColumnTypes);
			//Import data from datatable.		
            sheet1.ImportDataTable(customersTable,false,1,1,true);

			//Saving the workbook to disk.
			workbook.SaveAs("Sample.xls");
			//Close the workbook.
			workbook.Close();

			//No exception will be thrown if there are unsaved workbooks.
			excelEngine.ThrowNotSavedOnDestroy = false;
			excelEngine.Dispose(); 
			//Message box confirmation to view the created spreadsheet.
			if (MessageBox.Show ("Do you want to view the workbook?", "Workbook has been created",
				MessageBoxButtons.YesNo, MessageBoxIcon.Information)
				== DialogResult.Yes) 
			{
				//Launching the Excel file using the default Application.[MS Excel Or Free ExcelViewer]
				System.Diagnostics.Process.Start("Sample.xls");
				//Exit
				this.Close();
			}
			else
			{
				// Exit
				this.Close();
			}

		
		}
		

	}
}

